#include <hpgcc49.h>

//Simple piano program


int isMatrixKeyPressed(void){ 
//Returns TRUE if a key in the key matrix is pressed
//eg, it looks at all keys except for the shifts, alpha, and ON, 
//which are not part of the matrix
//this is hacked from the built in function keyb_isAnyKeyPressed(), 
//but strips out looking for ON, Shift and Alpha.
    unsigned int volatile * GPGDAT = (int*) 0x7A00064;
    return((*GPGDAT & 0xFE)!=0xFE) ;
}


void playTone(unsigned int tone){ 
//keeps playing a tone while any matrix key is pressed
//this is hacked from the built in function sys_playTone().

//basically to play a music, you toggle GPBDAT between 0x0 and 0x4
//which turns the beeper on and off

    unsigned int volatile * GPBDAT = (unsigned int*) 0x7A00014;

    //sys_waitTicks is current inaccurate for some reason. It should be 750KHz, 
    //but its more like 600kHz.

    unsigned int numTicks = 600000/(tone*2); //each cycle needs 2 delays

    while(isMatrixKeyPressed())
    {
        *GPBDAT=0x4;    //beeper on
        sys_waitTicks(numTicks); //wait
        *GPBDAT = 0;    //beeper off
        sys_waitTicks(numTicks); //wait
     }
}



int main(){

    sys_setupTimers(); //setup the timer to a known value
    clearScreen(); //clear the screen
    
    print("Piano Simulator",0,0); //print text to various locations
    print("[.] is C, [2] is D, etc. ",0,20);
    print("[1] is C#, [4] is D#, etc. ",0,26);
    print (__DATE__,0,60); //add in the compile date because I'm too lazy to use version numbers
    print("Press ON to quit",0,70);    
    
    while(!keyb_isON()){ //while the ON key is not pressed, scan the keyboard
    //see the manual for the meanings of the keycodes.

    //sharps
        if(keyb_isKeyPressed(3,5)) playTone(277*4);//C#
        if(keyb_isKeyPressed(3,4)) playTone(311*4);//D#
        
        if(keyb_isKeyPressed(3,2)) playTone(370*4);//F#    
        if(keyb_isKeyPressed(3,1)) playTone(415*4);//G#    
        if(keyb_isKeyPressed(3,0)) playTone(466*4);//A#

        if(keyb_isKeyPressed(6,4)) playTone(277*8);//C#
        if(keyb_isKeyPressed(5,1)) playTone(311*8);//D#

    //normal notes
    
        if(keyb_isKeyPressed(2,6)) playTone(262*4);//C
        if(keyb_isKeyPressed(2,5)) playTone(294*4);//D
        if(keyb_isKeyPressed(2,4)) playTone(330*4);//E        
        if(keyb_isKeyPressed(2,3)) playTone(349*4);//F
        if(keyb_isKeyPressed(2,2)) playTone(392*4);//G
        if(keyb_isKeyPressed(2,1)) playTone(440*4);//A
        if(keyb_isKeyPressed(2,0)) playTone(493*4);//B
        if(keyb_isKeyPressed(7,1)) playTone(262*8);//C    
        if(keyb_isKeyPressed(6,5)) playTone(294*8);//D    
        if(keyb_isKeyPressed(5,2)) playTone(330*8);//E
            
    }
    
    sys_restoreTimers(); //restore the timers to the OS defaults
    return 0; //we're done
}